assert( Necronomicon, "Necronomicon not found!")

-- Demon Skin
-- Demon Armor
-- Fel Armor
-- Pick and Choose between Demon or Fel. (LeftClick, RightClick)

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local hasfelarmor = nil
local hasdemonarmor = nil
local hasaura = nil

local felarmoricon = "Interface\\Icons\\Spell_Shadow_FelArmour"
local demonarmoricon = "Interface\\Icons\\Spell_Shadow_RagingScream" 

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconArmor = Necronomicon:NewModule("Armor")
NecronomiconArmor.name = "Armor"

NecronomiconArmor.revision = tonumber(string.sub("$Revision: 75659 $", 12, -3))

NecronomiconArmor.defaults = {
	posx = 296,
	posy = 200,
}

----------------------------------
--     Module Intialization     --
----------------------------------

local felArmor, demonArmor, demonSkin
function NecronomiconArmor:OnRegister()
	self:RegisterSpell(687) -- Demon Skin
	self:RegisterSpell(706) -- Demon Armor
	self:RegisterSpell(28176) -- Fel Armor
	felArmor = GetSpellInfo(28176)
	demonArmor = GetSpellInfo(706)
	demonSkin = GetSpellInfo(687)
end

function NecronomiconArmor:OnEnable()
	self:SetupButton()
	self:RegisterBucketEvent("UNIT_AURA", 0.5, "ScanAuras")
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:Necronomicon_SpellsUpdated()
	self:ScanAuras()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconArmor:Necronomicon_SpellsUpdated()
	local felarmor = self:HasSpell(28176) -- Fel Armor
	local demonarmor = self:HasSpell(706) -- Demon Armor
	local demonskin = self:HasSpell(687) -- Demon Skin
	
	local spell1 = ""
	local spell2 = ""
	local icon = nil

	if demonskin then
		spell1 = demonskin.spell
		icon = demonarmoricon
	end

	if demonarmor then
		spell1 = demonarmor.spell
		icon = demonarmoricon
	end

	if felarmor then
		spell2 = spell1
		spell1 = felarmor.spell
		icon = felarmoricon
	end
	
	self.button:SetAttribute("type1", "spell")
	self.button:SetAttribute("spell1", spell1)
	self.button:SetAttribute("type2", "spell")
	self.button:SetAttribute("spell2", spell2)

	self.button.background:SetTexture( icon )
	self:UpdateSaturation()
	self.button:Show()
end

function NecronomiconArmor:ScanAuras()
	local pindex, name, rank

	hasaura = nil

	for i = 1, 32 do
		pindex = GetPlayerBuff(i, "HELPFUL")
		name, rank = GetPlayerBuffName(pindex)
		if name and ( name == demonArmor or name == felArmor or name == demonSkin ) then
			hasaura = true
		end
	end
	self:UpdateSaturation()
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconArmor:UpdateSaturation()
	if hasaura then
		self.button.background:SetDesaturated( false )
	else
		self.button.background:SetDesaturated( true )
	end
end

function NecronomiconArmor:SetupButton()
	self:CreateButton()
	self.button.background:SetTexture( demonarmoricon )
	self:UpdateSaturation()
end
